<template>
    <div
        class="page-container"
    >
        <div class="video-button-container">
            <VideoButton :source="'https://carti.crisp.help/en/article/enable-sms-cart-abandonment-automation-1fnskde/reader'" />
        </div>
        <ValidationObserver
            ref="obs"
        >
            <div class="edit__top">
                <Tabs
                    ref="tabs"
                    :items="data"
                    @switch="tabIndex = $event"
                />
                <div
                    v-if="data"
                    class="edit__actions"
                >   
                    <template v-for="(item, index) in data">
                        <ToggleButton
                            v-if="index == tabIndex"
                            :key="index"
                            v-model="item.status"
                            :font-size="12"
                            class="toggle-btn"
                            :height="24"
                            :labels="true"
                            color="rgb(45, 119, 245)"
                            @change="saveReminders"
                        />
                    </template>
                    <Buttons
                        :items="btns"
                        @openPreviewPopup="openPreviewPopup"
                        @saveReminders="saveReminders"
                    />
                </div>
            </div>
            <div
                v-if="data"
                class="row"
            >
                <div class="col-12 col-xl-6">
                    <SmsFirstReminder
                        :data="data[tabIndex]"
                        @checkChanged="checkChanged"
                    />
                </div>
                <div class="col-12 col-xl-6">
                    <SmsPhonePreview
                        class="edit__preview"
                        :body-text="data[tabIndex].body_text"
                        :unsubscribe-text="data[tabIndex].unsubscribe_text"
                        :automatic-discount-enabled="data[tabIndex].automatic_discount_enabled"
                        :automatic-discount-value="data[tabIndex].automatic_discount_value"
                        :discount-code="data[tabIndex].code"
                    />
                </div>
            </div>
        </ValidationObserver>

        <SendTest
            v-if="previewPopup"
            ref="test"
            type="phone"
            :show-text="showAlertText"
            @send="sendPreview"
            @close="previewPopup = false"
        >   
            <template #unsaved>
                You have unsaved changes. We will send the last saved version of the message.
            </template>
        </SendTest>
        <DisabledCountriesModal
            v-if="sendData && showDisabledCountriesModal"
            ref="disabled_countries_modal"
            :show="showDisabledCountriesModal"
            :countries="sendData.disabledCountries"
            @confirm="sendPreview({smsValue: sendData.smsValue, averagePrice: sendData.averagePrice})"
            @close="closeDisabledCountriesModal"
        />
    </div>
</template>

<script>
import SmsFirstReminder from "@/components/sms/SmsFirstReminder";
import SmsPhonePreview from "@/components/sms/SmsPhonePreview";
import smsReminders from "@/mixins/sms/abandoned-carts.service";
import VideoButton from "@/components/header/VideoButton";
import {tags} from "@/mixins/add-tags"
import Tabs from "@/components/elements/Tabs"
import SendTest from "@/components/modals/SendTest"
import DisabledCountriesModal from '@/components/sms/DisabledCountriesModal'

import api from '@/services/settings.service.js'

export default {
    name: "SmsAbandonedTableEdit",
    components: {VideoButton, SmsPhonePreview, SmsFirstReminder, Tabs, SendTest, DisabledCountriesModal},
    mixins: [smsReminders, tags],
    data() {
        return {
            loading: true,
            data: null,
            tabIndex: 0,
            oldData: null,
            edited: [],
            showAlertText: false,
            showMaxPriceNotification: false,
            helpModalId: 'HelpModalSMSAbandoned',
            sendData: null,
            showDisabledCountriesModal: null,
            previewPopup: false,
            btns: [
                {title: 'Send Test', event: 'openPreviewPopup', class: 'light-blue-btn',},
                {title: 'Save', event: 'saveReminders', class: 'blue-btn',},
            ]
        }
    },
    async created() {
        this.getReminders();
        const data = await api.getAllCountries()
    },
    mounted() {
        this.tabIndex = parseInt(this.$route.params.id) - 1
        this.$refs.tabs.updTab(this.tabIndex)
    },
    methods: {
        titleTab(order) {
            if (order == 1){
                return  order + 'st Reminder'
            } else if (order == 2) {
                return  order + 'nd Reminder'
            } else if (order == 3) {
                return  order + 'rd Reminder'
            } else  {
                return  order + 'th Reminder'
            }
        },
        checkChanged(key) {
            const data = this.trackСhange(this.oldData[this.tabIndex], this.data[this.tabIndex], key)

            if(data.key) this.edited[this.tabIndex][data.key] = data.value
        },
        openPreviewPopup() {
            if(!this.previewPopup) this.showAlertText = this.checkEditedItems(this.edited[this.tabIndex])
            this.previewPopup = !this.previewPopup
        },
        getReminders() {
            this.getAllReminders().then(response => {
                const {data} =  response
                this.data = data.reminders.map((el, index) => ({
                    tabTitle: this.titleTab(index+1),
                    ...el,
                }))

                this.oldData = JSON.parse(JSON.stringify(response.data.reminders))
                this.edited = []
                this.oldData.forEach((el, index) => {
                    this.edited.push(this.createEditedObj(el))
                })
            })
            if(this.showAlertText) this.showAlertText = false
        },
        async saveReminders() {
            const result = await this.$refs.obs.validate();
            let valid = await this.$refs.obs
            if (result) {
                this.save({reminders: this.data}).then(() => {
                    this.$notify({
                        type: 'success',
                        title: 'Saved'
                    });
                    this.getReminders();
                })
                setTimeout(() => {
                    this.$refs.obs.reset()
                }, 2000)
            } else this.getFormErrors(valid.errors)

        },
        async sendPreview(item) {
            if(item.disabledCountries && item.disabledCountries.length) {
                this.sendData = item
                this.showDisabledCountriesModal = true
                this.previewPopup = false
                return
            }
            try {
                await this.sendPreviewSms(this.data[this.tabIndex].id, {
                    sms: item.smsValue,
                    averagePrice: item.averagePrice
                })
                this.previewPopup = false
                this.$notify({
                    type: 'success',
                    title: 'Sent'
                })
                this.closeDisabledCountriesModal()
            } catch (error) {
                console.log(error)
                this.$refs.test.stopLoading()
                this.$refs.disabled_countries_modal.stopLoading()
            }
        },
        closeDisabledCountriesModal() {
            this.sendData = false
            this.showDisabledCountriesModal = false
        }
    }
}
</script>

<style scoped lang="scss">

.average-price {
    text-align: right;
    margin-right: 42px;
    font-size: 12px;
}

.flag-image {
    width: 32px;
    margin-left: 10px;
}

.tag-container {
    display: flex;
    align-items: center;
}

.input-tag {
    padding: 8px;
    height: auto !important;
}

.btn {
    margin-right: 4px;
}

.sms-tab-container {
    margin-top: 20px;
}


.action-container {
    display: flex;
    align-items: center;
    float: right;
    justify-content: flex-end;
    margin-top: -62px;
    @media screen and (max-width: 1200px) {
        display: none !important;
    }
}

</style>
